Index: src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/Eml200SAXHandler.java	(revision 5311)
@@ -59,7 +59,7 @@
 import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /**
- * A database aware Class implementing callback bethods for the SAX parser to
+ * A database aware Class implementing callback methods for the SAX parser to
  * call when processing the XML stream and generating events
  * Here is the rules for user which has write permission in top level access
  * rules(he can update metadata but can't update access module) try to update
@@ -66,7 +66,7 @@
  * a document:
  * 1. Checking access part (both in top level and additional level, node by node)
  *    If something was modified, reject the document. Note: for additional part
- *    The access subtree startnode starts at "<describ>" rather than <access>.
+ *    The access subtree startnode starts at "<describe>" rather than <access>.
  *    This is because make sure ids wouldn't be mess up by user.
  * 2. Checking ids in additional access part, if they points a distribution
  *    module with online or inline. If some ids don't, reject the documents.
@@ -74,7 +74,7 @@
  *    If user can't read the inline data, the empty string in inline element
  *    will be send to user if he read this eml document(user has read access
  *    at top level - metadata, but user couldn't read inline data).
- *    Here is some intrested senario: If user does have read and write
+ *    Here is some interested scenario: If user does have read and write
  *    permission in top level access rules(for metadata)
  *    but 1) user doesn't have read and write permission in inline data block,
  *    so if user update the document with some inline data rather than
@@ -81,7 +81,7 @@
  *    empty string in same inline data block(same distribution inline id),
  *    this means user updated the inline data. So the document should be
  *    rejected.
- *    2) user doesn't have read permssion, but has write premission in
+ *    2) user doesn't have read permission, but has write permission in
  *    inline data block. If user send back inline data block with empty
  *    string, we will think user doesn't update inline data and we will
  *    copy old inline data back to the new one. If user send something
@@ -116,16 +116,27 @@
 public class Eml200SAXHandler extends DBSAXHandler implements
         AccessControlInterface
 {
-    private boolean processTopLeverAccess = false;
+	// Boolean that tells whether we are processing top level (document level) access.
+	// this is true when we hit an 'access' element, and the grandparent element is 
+	// 'eml' and we are not inside an 'additionalMetadata' section.  Set back to false
+	// in endElement
+    private boolean processTopLevelAccess = false;
 
     // now additionalAccess will be explained as distribution access control
     // - data file
     private boolean processAdditionalAccess = false;
 
+	// Boolean that tells whether we are processing other access. This is true when 
+    // we find an 'access' element inside an 'additionalMetadata' element.  Set back
+    // to false in endElement
     private boolean processOtherAccess = false;
 
+    // if we are inside an 'access' element, we use this object to hold the 
+    // current access info
     private AccessSection accessObject = null;
 
+    // for each 'access/allow' and 'access/deny' we create a new access Rule to hold
+    // the info
     private AccessRule accessRule = null;
 
     private Vector describesId = new Vector(); // store the ids in
@@ -157,7 +168,7 @@
     // temporarily store distribution id
     private String distributionId = null;
 
-    // flag to indicate to handle distrubiton
+    // flag to indicate to handle distribution
     private boolean proccessDistribution = false;
 
     // a hash table to stored the distribution which is a reference and this
@@ -171,14 +182,18 @@
     // id (300) will be stored in above distribution lists.
     private Hashtable distributionReferenceList = new Hashtable();
 
-    private boolean needCheckingAccessModule = false;
+    // if the action is update and the user does not have ALL permission 
+    // and the user is not an administrator, then we will need to compare 
+    // access modules to make sure the user has update permissions
+    private boolean needToCheckAccessModule = false;
 
-    private AccessSection unChangebleTopAccessSubTree = null;
+    private AccessSection topAccessSubTreeFromDB = null;
 
-    private Vector unChangebleAdditionalAccessSubTreeVector = new Vector();
+    private Vector additionalAccessSubTreeListFromDB = new Vector();
 
-    private Hashtable unChangebleReferencedAccessSubTreeHash = new Hashtable();
+    private Hashtable referencedAccessSubTreeListFromDB = new Hashtable();
 
+    // this holds the top level (document level) access section.
     private AccessSection topAccessSection;
 
     private Vector additionalAccessVector = new Vector();
@@ -206,7 +221,7 @@
 
     private Vector inlineFileIDList = new Vector();
 
-    private boolean inadditionalMetaData = false;
+    private boolean inAdditionalMetaData = false;
 
     //user has unwritable inline data object when it updates a document
     private boolean unWritableInlineDataObject = false;
@@ -322,7 +337,7 @@
             //unChangableSubTreeHash = getUnchangableSubTree(control, user,
             // groups);
 
-            //If the action is update and user doesn't have "ALL" permission
+            // If the action is update and user doesn't have "ALL" permission
             // we need to check if user update access subtree
             if (action != null && action.equals("UPDATE")
                     && !control.hasPermission(user, groups,
@@ -329,11 +344,11 @@
                             AccessControlInterface.ALLSTRING) 
                             && !AuthUtil.isAdministrator(user, groups))
             {
-                needCheckingAccessModule = true;
-                unChangebleTopAccessSubTree = getTopAccessSubTreeFromDB();
-                unChangebleAdditionalAccessSubTreeVector =
+                needToCheckAccessModule = true;
+                topAccessSubTreeFromDB = getTopAccessSubTreeFromDB();
+                additionalAccessSubTreeListFromDB =
                                          getAdditionalAccessSubTreeListFromDB();
-                unChangebleReferencedAccessSubTreeHash =
+                referencedAccessSubTreeListFromDB =
                                          getReferencedAccessSubTreeListFromDB();
             }
 
@@ -596,7 +611,7 @@
 
             //start handle inline data
             //=====================================================
-            if (qName.equals(INLINE) && !inadditionalMetaData)
+            if (qName.equals(INLINE) && !inAdditionalMetaData)
             {
                 handleInlineData = true;
                 inLineDataIndex++;
@@ -654,8 +669,8 @@
             {
 
 
-                if (needCheckingAccessModule
-                        && (processAdditionalAccess || processOtherAccess || processTopLeverAccess)) {
+                if (needToCheckAccessModule
+                        && (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
                     // stored the pull out nodes into storedNode stack
                     NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT",
                             null, null, MetacatUtil.normalize(textBuffer
@@ -807,7 +822,7 @@
               }
               else if (attributeName != null && attributeName.equals(ID) &&
                        currentNode.getTagName().equals(DISTRIBUTION) &&
-                       !inadditionalMetaData)
+                       !inAdditionalMetaData)
               {
                  // this is a distribution element and the id is distributionID
                  distributionId = attributeValue;
@@ -834,12 +849,12 @@
                 // put parent node back
                 nodeStack.push(tmpNode);
                 String grandParentTag = grandParentNode.getTagName();
-                if (grandParentTag.equals(EML) && !inadditionalMetaData)
+                if (grandParentTag.equals(EML) && !inAdditionalMetaData)
                 {
-                  processTopLeverAccess = true;
+                  processTopLevelAccess = true;
 
                 }
-                else if ( !inadditionalMetaData )
+                else if ( !inAdditionalMetaData )
                 {
                   // process other access embedded into resource level
                   // module
@@ -847,11 +862,10 @@
                 }
                 else
                 {
-                  // this for access in additional data which don't have
-                  // described element. If it has a descirbed element,
-                  // this code would hurt any thing
+                  // this for access in additional data which doesn't have a
+                  // described element. If it has a described element,
+                  // this code won't hurt any thing
                   processAdditionalAccess = true;
-                  logMetacat.info("accessing process additional access true when meet access");
                 }
 
 
@@ -871,7 +885,7 @@
                   accessObject.setStartedDescribesNodeId(firstDescribesNodeId);
                   accessObject.setControlLevel(DATAACCESSLEVEL);
                 }
-                else if (processTopLeverAccess)
+                else if (processTopLevelAccess)
                 {
                   accessObject.setControlLevel(TOPLEVEL);
                 }
@@ -918,8 +932,8 @@
             nodeIndex.addElement(currentNode);
 
             // store access module element and attributes into stored stack
-            if (needCheckingAccessModule
-                    && (processAdditionalAccess || processOtherAccess || processTopLeverAccess))
+            if (needToCheckAccessModule
+                    && (processAdditionalAccess || processOtherAccess || processTopLevelAccess))
             {
                 // stored the pull out nodes into storedNode stack
                 NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "ELEMENT",
@@ -938,7 +952,7 @@
 
             if (currentNode.getTagName().equals(ADDITIONALMETADATA))
             {
-              inadditionalMetaData = true;
+              inAdditionalMetaData = true;
             }
             else if (currentNode.getTagName().equals(DESCRIBES) &&
                      parentNode.getTagName().equals(ADDITIONALMETADATA) &&
@@ -954,7 +968,7 @@
               processAdditionalAccess = true;
               logMetacat.info("set processAdditonalAccess true when meet describe");
             }
-            else if (inadditionalMetaData && processAdditionalAccess &&
+            else if (inAdditionalMetaData && processAdditionalAccess &&
                      parentNode.getTagName().equals(ADDITIONALMETADATA) &&
                      !currentNode.getTagName().equals(DESCRIBES) &&
                      !currentNode.getTagName().equals(ACCESS))
@@ -971,7 +985,7 @@
                logMetacat.warn("set processAddtionAccess false if the there is no access in additional");
             }
             else if (currentNode.getTagName().equals(DISTRIBUTION) &&
-                     !inadditionalMetaData)
+                     !inAdditionalMetaData)
             {
               proccessDistribution = true;
             }
@@ -1053,8 +1067,8 @@
                 DBSAXNode currentNode = (DBSAXNode) nodeStack.peek();
                 endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer,
                         currentNode);
-                if (needCheckingAccessModule
-                     && (processAdditionalAccess || processOtherAccess || processTopLeverAccess))
+                if (needToCheckAccessModule
+                     && (processAdditionalAccess || processOtherAccess || processTopLevelAccess))
                 {
                      // stored the pull out nodes into storedNode stack
                      NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT",
@@ -1237,7 +1251,7 @@
                     //firstDescribesNodeId = 0;
                 }
                 else if (currentTag.equals(REFERENCES)
-                        && (processTopLeverAccess || processAdditionalAccess || processOtherAccess))
+                        && (processTopLevelAccess || processAdditionalAccess || processOtherAccess))
                 {
                     // get reference
                     data = (textBuffer.toString()).trim();
@@ -1257,7 +1271,7 @@
                   }
 
                 }
-                else if (currentTag.equals(URL) && !inadditionalMetaData)
+                else if (currentTag.equals(URL) && !inAdditionalMetaData)
                 {
                     //handle online data, make sure its'parent is online
                     DBSAXNode parentNode = (DBSAXNode) nodeStack.peek();
@@ -1284,8 +1298,8 @@
                  endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer,
                             currentNode);
 
-                if (needCheckingAccessModule
-                        && (processAdditionalAccess || processOtherAccess || processTopLeverAccess)) {
+                if (needToCheckAccessModule
+                        && (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
                     // stored the pull out nodes into storedNode stack
                     NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT",
                             null, null, MetacatUtil.normalize(textBuffer
@@ -1325,7 +1339,7 @@
                 if (newAccessObject != null)
                 {
 
-                    if (processTopLeverAccess)
+                    if (processTopLevelAccess)
                     {
                        topAccessSection = newAccessObject;
 
@@ -1362,7 +1376,7 @@
 
                 // reset flag
                 processAdditionalAccess = false;
-                processTopLeverAccess = false;
+                processTopLevelAccess = false;
                 processOtherAccess = false;
 
             }//access element
@@ -1371,7 +1385,7 @@
                 //reset describesId
                 describesId = null;
                 describesId = new Vector();
-                inadditionalMetaData = false;
+                inAdditionalMetaData = false;
                 firstDescribesNodeId = -1;
                 // reset tmp stored node stack
                 storedAccessNodeStack = null;
@@ -1379,13 +1393,13 @@
 
 
             }
-            else if (currentTag.equals(DISTRIBUTION) && !inadditionalMetaData)
+            else if (currentTag.equals(DISTRIBUTION) && !inAdditionalMetaData)
             {
                //reset distribution id
                distributionId = null;
                proccessDistribution = false;
             }
-            else if (currentTag.equals(OFFLINE) && !inadditionalMetaData)
+            else if (currentTag.equals(OFFLINE) && !inAdditionalMetaData)
             {
                if (distributionId != null)
                {
@@ -1393,7 +1407,7 @@
                }
             }
             else if ((currentTag.equals(CONNECTION) || currentTag.equals(CONNECTIONDEFINITION))
-                     && !inadditionalMetaData)
+                     && !inAdditionalMetaData)
             {
               //handle online data, make sure its'parent is online
                  DBSAXNode parentNode = (DBSAXNode) nodeStack.peek();
@@ -1537,14 +1551,14 @@
                             str, PERMISSIONERROR);
                 }//if*/
                 //compare top level access module
-                if (processTopLeverAccess && needCheckingAccessModule) {
+                if (processTopLevelAccess && needToCheckAccessModule) {
                     /*compareCommentNode(currentUnchangableAccessModuleNodeStack,
                             str, UPDATEACCESSERROR);*/
                 }
                 endNodeId = currentNode.writeChildNodeToDB("COMMENT", null,
                         str, docid);
-                if (needCheckingAccessModule
-                        && (processAdditionalAccess || processOtherAccess || processTopLeverAccess)) {
+                if (needToCheckAccessModule
+                        && (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
                     // stored the pull out nodes into storedNode stack
                     NodeRecord nodeElement = new NodeRecord(-2, -2, -2,
                             "COMMENT", null, null, MetacatUtil.normalize(str));
@@ -1621,13 +1635,13 @@
             String data = new String(cbuf, start, len);
 
                 //compare whitespace in access top module
-                if (processTopLeverAccess && needCheckingAccessModule) {
+                if (processTopLevelAccess && needToCheckAccessModule) {
                     /*compareWhiteSpace(currentUnchangableAccessModuleNodeStack,
                             data, UPDATEACCESSERROR);*/
                 }
                 // Write the content of the node to the database
-                if (needCheckingAccessModule
-                        && (processAdditionalAccess || processOtherAccess || processTopLeverAccess)) {
+                if (needToCheckAccessModule
+                        && (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
                     // stored the pull out nodes into storedNode stack
                     NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT",
                             null, null, MetacatUtil.normalize(data));
@@ -1650,7 +1664,7 @@
     public void endDocument() throws SAXException
     {
         logMetacat.info("end Document");
-        if (needCheckingAccessModule)
+        if (needToCheckAccessModule)
         {
           compareAllAccessModules();
         }
@@ -1691,10 +1705,10 @@
     private void compareAllAccessModules() throws SAXException
     {
       //compare top level
-      compareAccessSubtree(unChangebleTopAccessSubTree, topAccessSection);
+      compareAccessSubtree(topAccessSubTreeFromDB, topAccessSection);
 
       //compare additional level
-      int oldSize = unChangebleAdditionalAccessSubTreeVector.size();
+      int oldSize = additionalAccessSubTreeListFromDB.size();
       int newSize = additionalAccessVector.size();
       // if size is different, use deleted or added rules, so throw a exception
       if (oldSize != newSize)
@@ -1706,7 +1720,7 @@
       for ( int i = 0; i < newSize; i++)
       {
         AccessSection fromDB = (AccessSection)
-                          unChangebleAdditionalAccessSubTreeVector.elementAt(i);
+                          additionalAccessSubTreeListFromDB.elementAt(i);
         AccessSection fromParser = (AccessSection)
                                 additionalAccessVector.elementAt(i);
         compareAccessSubtree(fromDB, fromParser);
@@ -1713,12 +1727,12 @@
       }
 
       //compare referenced level
-      Enumeration em = unChangebleReferencedAccessSubTreeHash.keys();
+      Enumeration em = referencedAccessSubTreeListFromDB.keys();
       while (em.hasMoreElements())
       {
         String id = (String)em.nextElement();
         AccessSection fromDB = (AccessSection)
-                               unChangebleReferencedAccessSubTreeHash.get(id);
+                               referencedAccessSubTreeListFromDB.get(id);
         AccessSection fromParser = (AccessSection)
                                possibleReferencedAccessHash.get(id);
         compareAccessSubtree(fromDB, fromParser);
@@ -1926,7 +1940,7 @@
      //System.out.println("in write additional");
      // we should delete all inline access rules in xml_access if
      // user has all permission
-     if (!needCheckingAccessModule)
+     if (!needToCheckAccessModule)
      {
        deleteAllInlineDataAccessRules();
      }
Index: src/edu/ucsb/nceas/metacat/NodeRecord.java
===================================================================
--- src/edu/ucsb/nceas/metacat/NodeRecord.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/NodeRecord.java	(revision 5311)
@@ -32,14 +32,14 @@
  * A utility class that encapsulates a node and its data
  */
 public class NodeRecord {
-  private long nodeid = -1;
-  private long parentnodeid = -1;
-  private long nodeindex = -1;
-  private String nodename = null;
-  private String nodeprefix = null;
-  private String nodetype = null;
-  private String nodedata = null;
-  private float nodedatanumerical = -1;
+  private long _nodeid = -1;
+  private long _parentnodeid = -1;
+  private long _nodeindex = -1;
+  private String _nodename = null;
+  private String _nodeprefix = null;
+  private String _nodetype = null;
+  private String _nodedata = null;
+  private float _nodedatanumerical = -1;
   private Logger logMetacat = Logger.getLogger(NodeRecord.class);
 
   /**
@@ -48,68 +48,66 @@
   public NodeRecord(long nodeid, long parentnodeid, long nodeindex,
                     String nodetype, String nodename, String nodeprefix, 
                     String nodedata) {
-    this.nodeid = nodeid;
-    this.parentnodeid = parentnodeid;
-    this.nodeindex = nodeindex;
-    this.nodename = nodename;
-    this.nodeprefix = nodeprefix;
-    this.nodetype = nodetype;
-    this.nodedata = nodedata;
+	    setNodeId(nodeid);
+	    setParentNodeId(parentnodeid);
+	    setNodeIndex(nodeindex);
+	    setNodeName(nodename);
+	    setNodePrefix(nodeprefix);
+	    setNodeType(nodetype);
+	    setNodeData(nodedata);
   }
   
+  public NodeRecord(long nodeid, long parentnodeid, long nodeindex, String nodetype,
+			String nodename, String nodeprefix, String nodedata, float nodedatanumerical) {
+		setNodeId(nodeid);
+		setParentNodeId(parentnodeid);
+		setNodeIndex(nodeindex);
+		setNodeName(nodename);
+		setNodePrefix(nodeprefix);
+		setNodeType(nodetype);
+		setNodeData(nodedata);
+		setNodeDataNumerical(nodedatanumerical);
+	}
   
-  public NodeRecord(long nodeid, long parentnodeid, long nodeindex,
-                    String nodetype, String nodename, String nodeprefix, 
-                    String nodedata, float nodedatanumerical) {
-    this.nodeid = nodeid;
-    this.parentnodeid = parentnodeid;
-    this.nodeindex = nodeindex;
-    this.nodename = nodename;
-    this.nodeprefix = nodeprefix;
-    this.nodetype = nodetype;
-    this.nodedata = nodedata;
-    this.nodedatanumerical = nodedatanumerical;
-  }
-  
-  /** Get functions*/
+  /** Get functions */
   public long getNodeId()
   {
-    return nodeid;
+    return _nodeid;
   }
   
   public long getParentNodeId()
   {
-    return parentnodeid;
+    return _parentnodeid;
   }
   
   public long getNodeIndex()
   {
-    return nodeindex;
+    return _nodeindex;
   }
   
   public String getNodeName()
   {
-    return nodename;
+    return _nodename;
   }
   
   public String getNodeType()
   {
-    return nodetype;
+    return _nodetype;
   }
   
   public String getNodePrefix()
   {
-    return nodeprefix;
+    return _nodeprefix;
   }
   
   public String getNodeData()
   {
-    return nodedata;
+    return _nodedata;
   }
 
   public float getNodeDataNumerical()
   {
-    return nodedatanumerical;
+    return _nodedatanumerical;
   }
   
   /** Setter methods **/
@@ -119,8 +117,8 @@
    *
    * @param id  the new value of the id
    */
-  public void setNodeId (long id){
-    this.nodeid = id;
+  public void setNodeId (long id) {
+	  _nodeid = id;
   }
   
   /**
@@ -128,8 +126,8 @@
    *
    * @param parentid  the new value of the parent id
    */
-  public void setParentNodeId (long parentid){
-    this.parentnodeid = parentid;
+  public void setParentNodeId (long parentid) {
+	  _parentnodeid = parentid;
   }
   
   /**
@@ -137,8 +135,12 @@
    *
    * @param name  the new value of the node name
    */
-  public void setNodeName (String name){
-    this.nodename = name;
+  public void setNodeName (String name) {
+	  if (name != null) {
+		  _nodename = name.trim();
+	  } else {
+		  _nodename = null;
+	  }
   }
   
   /**
@@ -146,8 +148,12 @@
    *
    * @param prefix  the new value of the node prefix
    */
-  public void setNodePrefix (String prefix){
-    this.nodeprefix = prefix;
+  public void setNodePrefix (String prefix) {
+	  if (prefix != null) {
+		  _nodeprefix = prefix.trim(); 
+	  } else {
+		  _nodeprefix = null;
+	  }
   }
   
   /**
@@ -155,8 +161,8 @@
    *
    * @param index  the new value of the node index
    */
-  public void setNodeIndex (long index){
-    this.nodeindex = index;
+  public void setNodeIndex (long index) {
+	  _nodeindex = index;
   }
   
   /**
@@ -164,8 +170,12 @@
    *
    * @param type  the new value of the node type
    */ 
-  public void setNodeType (String type){
-    this.nodetype = type;
+  public void setNodeType (String type) {
+	  if (type != null) {
+		  _nodetype = type.trim();
+	  } else {
+		  _nodetype = null;
+	  }
   }
   
   /**
@@ -173,8 +183,12 @@
    *
    * @param data  the new value of the node data
    */
-  public void setNodeData (String data){
-    this.nodedata = data;
+  public void setNodeData (String data) {
+	  if (data != null) {
+		  _nodedata = data.trim();
+	  } else {
+		  _nodedata = null;
+	  }
   }
   
   /**
@@ -183,7 +197,7 @@
    * @param datanumerical  the new value of the numerical node data
    */     
   public void setNodeDataNumerical (float datanumerical){
-    this.nodedatanumerical = datanumerical;
+    _nodedatanumerical = datanumerical;
   }
   
   /** Method compare two records */
@@ -190,42 +204,42 @@
   public boolean contentEquals(NodeRecord record)
   {
     boolean flag = true;
-    logMetacat.info("First nodetype: "+this.nodetype);
-    logMetacat.info("Second nodetype: "+record.getNodeType());
-    logMetacat.info("First nodename: "+this.nodename);
-    logMetacat.info("Second nodename: "+record.getNodeName());
-    logMetacat.info("First nodeprefix: "+this.nodeprefix);
-    logMetacat.info("Second nodeprefix: "+record.getNodePrefix());
-    logMetacat.info("First nodedata: "+this.nodedata);
-    logMetacat.info("Second nodedata: "+record.getNodeData());
-    if ((this.nodename == null && record.getNodeName() != null) ||
-        (this.nodename != null && record.getNodeName() == null) ||
-        (this.nodename != null && record.getNodeName() != null &&
-        !(this.nodename).equals(record.getNodeName())))
+    logMetacat.info("First nodetype: " + _nodetype);
+    logMetacat.info("Second nodetype: " + record.getNodeType());
+    logMetacat.info("First nodename: " + _nodename);
+    logMetacat.info("Second nodename: " + record.getNodeName());
+    logMetacat.info("First nodeprefix: " + _nodeprefix);
+    logMetacat.info("Second nodeprefix: " + record.getNodePrefix());
+    logMetacat.info("First nodedata: " + _nodedata);
+    logMetacat.info("Second nodedata: " + record.getNodeData());
+    if ((_nodename == null && record.getNodeName() != null) ||
+        (_nodename != null && record.getNodeName() == null) ||
+        (_nodename != null && record.getNodeName() != null &&
+        !(_nodename).equals(record.getNodeName())))
     {
       //compare nodename
       flag = false;
     }
-    else if ((this.nodetype == null && record.getNodeType() != null) ||
-             (this.nodetype != null && record.getNodeType() == null) ||
-             (this.nodetype != null && record.getNodeType() != null &&
-             !(this.nodetype).equals(record.getNodeType())))
+    else if ((_nodetype == null && record.getNodeType() != null) ||
+             (_nodetype != null && record.getNodeType() == null) ||
+             (_nodetype != null && record.getNodeType() != null &&
+             !(_nodetype).equals(record.getNodeType())))
     {
       // compare node type
       flag = false;
     }
-    else if ((this.nodeprefix == null && record.getNodePrefix() != null) ||
-             (this.nodeprefix != null && record.getNodePrefix() == null) ||
-             (this.nodeprefix != null && record.getNodePrefix() != null &&
-             !(this.nodeprefix).equals(record.getNodePrefix())))
+    else if ((_nodeprefix == null && record.getNodePrefix() != null) ||
+             (_nodeprefix != null && record.getNodePrefix() == null) ||
+             (_nodeprefix != null && record.getNodePrefix() != null &&
+             !(_nodeprefix).equals(record.getNodePrefix())))
     {
       // compare node prefix
       flag = false;
     }
-    else if ((this.nodedata == null && record.getNodeData() != null) ||
-             (this.nodedata != null && record.getNodeData() == null) ||
-             (this.nodedata != null && record.getNodeData() != null &&
-             !(this.nodedata).equals(record.getNodeData())))
+    else if ((_nodedata == null && record.getNodeData() != null) ||
+             (_nodedata != null && record.getNodeData() == null) ||
+             (_nodedata != null && record.getNodeData() != null &&
+             !(_nodedata).equals(record.getNodeData())))
     {
       // compare node data
       flag = false;
